package nq.utils.task {
	
	import flash.events.Event;
	
	/**
	 * Событие очереди задач
	 * 
	 * @author gloomyBrain
	 */
	public final class TaskQueueEvent extends Event {
		
		/**
		 * Все задания в очереди завершены
		 */
		public static const QUEUE_COMPLETE:String = "queueComplete";
		
		/**
		 * Задание сейчас начнет выполняться
		 */
		public static const BEFORE_TASK_START:String = "beforeTaskStart";
		
		/**
		 * Задание завершено
		 */
		public static const TASK_COMPLETE:String = "taskComplete";
		
		/**
		 * Задание выполнить не удалось
		 */
		public static const TASK_FAIL:String = "taskFail";
		
		
		private var _task:ITask;
		
		public function TaskQueueEvent(type:String, task:ITask = null) {
			
			super(type);
			
			_task = task;
			
		}
		
		public override function clone():Event {
			return new TaskQueueEvent(type, _task);
		}
		
		public override function toString():String {
			return formatToString("TaskQueueEvent", "type", "task", "eventPhase");
		}
		
		/**
		 * Связанное с событием задание
		 */
		public function get task():ITask {
			return _task;
		}
		
	}
	
}